classification
Title: libffi update to 3.0.9
Type: enhancement Stage: resolved
Components: ctypes Versions: Python 3.2, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: doko Nosy List: akrpic77, doko, flox, haypo, loewis, ned.deily, nick, theller
Priority: normal Keywords: buildbot, patch

Created on 2010-03-14 23:40 by doko, last changed 2010-08-08 21:51 by flox. This issue is now closed.

Files
File name Uploaded Description Edit
libffi-update3.diff doko, 2010-03-19 17:53
Messages (18)
msg101072 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-03-14 23:40
opening a report to track issues with the update of the internal libffi copy to 3.0.9.  will commit this update to the trunk, and later to the py3k branch.
msg101104 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-03-15 13:28
updated on the trunk and the py3k branch
msg101134 - (view) Author: Florent Xicluna (flox) * (Python committer) Date: 2010-03-15 19:15
I noticed some failures on Sparc Solaris10 buildbots (both trunk and 3.x)

======================================================================
FAIL: test_ulonglong (ctypes.test.test_callbacks.Callbacks)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/home2/buildbot/slave/trunk.loewis-sun/build/Lib/ctypes/test/test_callbacks.py", line 68, in test_ulonglong
    self.check_type(c_ulonglong, 42)
  File "/home2/buildbot/slave/trunk.loewis-sun/build/Lib/ctypes/test/test_callbacks.py", line 31, in check_type
    self.assertEqual(result, arg)
AssertionError: 0L != 42

----------------------------------------------------------------------
Ran 325 tests in 3.088s

FAILED (failures=1)
test test_ctypes failed -- Traceback (most recent call last):
  File "/home2/buildbot/slave/trunk.loewis-sun/build/Lib/ctypes/test/test_callbacks.py", line 68, in test_ulonglong
    self.check_type(c_ulonglong, 42)
  File "/home2/buildbot/slave/trunk.loewis-sun/build/Lib/ctypes/test/test_callbacks.py", line 31, in check_type
    self.assertEqual(result, arg)
AssertionError: 0L != 42
msg101219 - (view) Author: Florent Xicluna (flox) * (Python committer) Date: 2010-03-17 10:53
re-opened to track the issue on Sparc Solaris
msg101221 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-03-17 12:44
no access to solaris hardware. please could you run the libffi testsuite on this machine? make sure that expect is installed.
msg101230 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-03-17 15:27
the ports which are maintained separately still need an update:

libffi_msvc
  libffi trunk now has a port to x86/msvc. might require some
  extra updates from libffi.

libffi_osx:
  3.0.9 has support for darwin on powerpc and x86

libffi_wince:
  same, support seems to be included.
msg101263 - (view) Author: Thomas Heller (theller) * (Python committer) Date: 2010-03-18 15:44
> the ports which are maintained separately still need an update:
> 
> libffi_msvc
>   libffi trunk now has a port to x86/msvc. might require some
>   extra updates from libffi.

I'll take care of this one.
Would it be a good idea to upgrade to libffi trunk
in Modules/_ctypes/libffi, and get rid of the libffi_msvc
fork completely (by applying an additional small patch)?
msg101264 - (view) Author: Florent Xicluna (flox) * (Python committer) Date: 2010-03-18 15:48
> no access to solaris hardware. please could you run the libffi
> testsuite on this machine? make sure that expect is installed.

I don't have access to such hardware.
I noticed the buildbot failures since libffi was upgraded.
msg101322 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2010-03-19 11:17
(Adding Ronald for OS X.)
msg101330 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-03-19 15:03
On 18.03.2010 16:44, Thomas Heller wrote:
> 
> Thomas Heller<theller@ctypes.org>  added the comment:
> 
>> the ports which are maintained separately still need an update:
>>
>> libffi_msvc
>>    libffi trunk now has a port to x86/msvc. might require some
>>    extra updates from libffi.
> 
> I'll take care of this one.
> Would it be a good idea to upgrade to libffi trunk
> in Modules/_ctypes/libffi, and get rid of the libffi_msvc
> fork completely (by applying an additional small patch)?

I'm attaching the patch for an update from the trunk; it passes the ctypes tests and the libffi testsuite on i486-linux-gnu.

We should revert the following chunk for configure.ac to generate the Makefile's again, so that we are able to run the testsuite at least with dejagnu:

-AC_CONFIG_FILES(include/Makefile include/ffi.h Makefile testsuite/Makefile man/Makefile libffi.pc)
+AC_CONFIG_FILES(include/ffi.h)
msg101335 - (view) Author: Thomas Heller (theller) * (Python committer) Date: 2010-03-19 16:34
> We should revert the following chunk for configure.ac to generate the Makefile's again, so that we are able to run the testsuite at least with dejagnu:
> 
> -AC_CONFIG_FILES(include/Makefile include/ffi.h Makefile testsuite/Makefile man/Makefile libffi.pc)
> +AC_CONFIG_FILES(include/ffi.h)

Can you make this change, run autoconf (I have only version 2.64 but 2.65 is needed), and commit please?
msg101338 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-03-19 17:53
> Can you make this change, run autoconf, and commit please?

done, and updated the patch for the merge from the trunk.
msg101340 - (view) Author: Thomas Heller (theller) * (Python committer) Date: 2010-03-19 18:41
> done, and updated the patch for the merge from the trunk.
> 
> ----------
> Added file: http://bugs.python.org/file16590/libffi-update3.diff

This patch passes the ctypes tests and libffi testsuite on this system:

  Linux tubu64 2.6.24-27-generic #1 SMP Fri Mar 12 00:52:19 UTC 2010 x86_64 GNU/Linux

Please apply.  And thanks for all the help...
msg101491 - (view) Author: Florent Xicluna (flox) * (Python committer) Date: 2010-03-22 10:22
See this post, about Solaris failure:
http://bugs.python.org/issue1544339#msg101485

And the proposed patch:
http://sourceware.org/ml/libffi-discuss/2010/msg00016.html
msg101492 - (view) Author: Florent Xicluna (flox) * (Python committer) Date: 2010-03-22 10:30
Ignore my last comment. It is not relevant, and the patch is already in 3.0.9.
msg106061 - (view) Author: Florent Xicluna (flox) * (Python committer) Date: 2010-05-19 13:19
It seems fixed now.
msg107618 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2010-06-12 00:49
Reopen the issue: libffi compilation fails on "x86 FreeBSD 3.x" buildbot.

http://www.python.org/dev/buildbot/builders/x86%20FreeBSD%203.x/builds/349/steps/compile/logs/stdio

gcc -pthread -fPIC -fno-strict-aliasing -g -O2 -g -O0 -Wall -Wstrict-prototypes -Ibuild/temp.freebsd-6.4-RELEASE-i386-3.2-pydebug/libffi/include -Ibuild/temp.freebsd-6.4-RELEASE-i386-3.2-pydebug/libffi -I/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Modules/_ctypes/libffi/src -IInclude -I./Include -I/usr/local/include -I/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Include -I. -c /usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Modules/_ctypes/libffi/src/x86/sysv.S -o build/temp.freebsd-6.4-RELEASE-i386-3.2-pydebug/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Modules/_ctypes/libffi/src/x86/sysv.o
/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Modules/_ctypes/libffi/src/x86/sysv.S: Assembler messages:
/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Modules/_ctypes/libffi/src/x86/sysv.S:360: Error: junk at end of line, first unrecognized character is `@'
/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Modules/_ctypes/libffi/src/x86/sysv.S:387: Error: junk at end of line, first unrecognized character is `@'
/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Modules/_ctypes/libffi/src/x86/sysv.S:423: Error: junk at end of line, first unrecognized character is `@'
msg113332 - (view) Author: Florent Xicluna (flox) * (Python committer) Date: 2010-08-08 21:51
"x86 FreeBSD 3.x" buildbot seems to compile "libffi".
History
Date User Action Args
2010-08-08 21:51:05floxsetstatus: open -> closed
resolution: fixed
messages: + msg113332
2010-06-12 04:21:48ronaldoussorensetnosy: - ronaldoussoren
2010-06-12 00:49:42hayposetstatus: closed -> open

nosy: + haypo
messages: + msg107618

resolution: fixed -> (no value)
2010-05-24 21:52:07floxsetstatus: open -> closed
2010-05-24 18:41:08akrpic77setstatus: pending -> open
nosy: + akrpic77
2010-05-19 13:19:10floxsetstatus: open -> pending
resolution: fixed
messages: + msg106061

stage: needs patch -> resolved
2010-03-22 10:30:03floxsetmessages: + msg101492
2010-03-22 10:22:40floxsetnosy: + nick
messages: + msg101491
2010-03-19 18:41:55thellersetmessages: + msg101340
2010-03-19 17:53:55dokosetfiles: - libffi-update2.diff
2010-03-19 17:53:37dokosetfiles: + libffi-update3.diff

messages: + msg101338
2010-03-19 16:34:19thellersetmessages: + msg101335
2010-03-19 15:04:04dokosetfiles: + libffi-update2.diff
keywords: + patch
messages: + msg101330
2010-03-19 11:17:41ned.deilysetnosy: + ned.deily, ronaldoussoren
messages: + msg101322
2010-03-18 15:48:26floxsetkeywords: + buildbot
nosy: + loewis
messages: + msg101264

2010-03-18 15:44:05thellersetmessages: + msg101263
2010-03-17 15:27:04dokosetmessages: + msg101230
2010-03-17 12:44:06dokosetmessages: + msg101221
2010-03-17 10:53:08floxsetstatus: closed -> open
resolution: fixed -> (no value)
messages: + msg101219

stage: needs patch
2010-03-15 19:15:16floxsetpriority: normal
nosy: + flox
messages: + msg101134

2010-03-15 13:28:31dokosetstatus: open -> closed
resolution: fixed
messages: + msg101104
2010-03-14 23:46:55dokosetassignee: theller -> doko
2010-03-14 23:40:04dokocreate